using NinjaTrader.Cbi;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.Design;
using System;
using System.ComponentModel;

namespace NinjaTrader.Data
{
    
    public class RenkoPercent : BarsType
    {
        private bool bInit;
        private int cDate;
        private double cTick;
        private int cTickIgnore;
        private double cTime;
        private long cVolume;
        private bool gVal;
        private double hlfRng;
        private double hlfRngDraw;
        private long iVolume;
        private double lTime;
        private double nHigh;
        private double nLow;
        private int pBarDir;
        private double pClose;
        private int pDate;
        private double pTick;
        private int pTickIgnore;
        private double pTime;
        private static bool registered = BarsType.Register(new RenkoPercent());
        private int vFilter;
        private double vInputRng;
        private int vIntraCalc;
        private int vReference;
        private double vRevSize;
        private double vRevSizeDraw;
        private int vTickCount;
        private double vTickMult;
        private double vUseRng;
        private int vWick;

        public RenkoPercent() : base(PeriodType.Custom7)
        {
              vTickMult = 1.0;
              vIntraCalc = 1;
              vRevSize = 2.0;
              vRevSizeDraw = 1.0;
              vUseRng = double.MaxValue;
              vFilter = 1;
              vReference = 2;
              vWick = 1;
        }

        public override void Add(Bars bars, double open, double high, double low, double close, DateTime time, long volume, bool isRealtime)
        {
            if (!  bInit)
            {
                  bInit = true;
                  gVal =   CountBars();
            }
            if (!  gVal)
            {
                return;
            }
            double num = 0.0;
            double num2 = 0.0;
              pTick =   cTick;
              cTick = close;
              pDate =   cDate;
              cDate = time.Date.DayOfYear;
              pTime =   cTime;
              cTime = time.TimeOfDay.TotalMilliseconds;
              pTickIgnore =   cTickIgnore;
              cTickIgnore = 0;
            if ((((  vFilter == 1) && !bars.IsNewSession(time)) && ((  cTick != 0.0) && (  pTick != 0.0))) && ((Math.Abs((double) (  cTime -   pTime)) < 1.0) && (Math.Abs((double) (  cTick -   pTick)) >=   vUseRng)))
            {
                  cTickIgnore = 1;
                return;
            }
            if (high >   nHigh)
            {
                  nHigh = high;
            }
            if (low <   nLow)
            {
                  nLow = low;
            }
            if (  vTickMult == 10.0)
            {
                if (volume > 1000)
                {
                      iVolume = volume / 100000;
                }
                else
                {
                      iVolume = volume / 10L;
                }
            }
            else if (volume <= 10L)
            {
                  iVolume = volume * 100L;
            }
            else
            {
                  iVolume = volume;
            }
              vTickCount++;
            if ((bars.Count == 0) || bars.IsNewSession(time))
            {
                  GetInputs(bars, close, time);
                  nHigh = 0.0;
                  nLow = double.MaxValue;
                  pBarDir = 0;
                if (bars.Count != 0)
                {
                    bars.RemoveLastBar(isRealtime);
                }
                 AddBar(bars, close, close, close, close, time, volume, isRealtime);
                bars.LastPrice = close;
                  pClose = close;
                return;
            }
            Bar bar1 = (Bar) bars.Get(bars.Count - 1);
            if ((((  pBarDir != -1) || (close <=   pClose)) || (Math.Abs((double) (  pClose - close)) < (  vUseRng *   vRevSize))) && (((  pBarDir < 0) || (close <=   pClose)) || (Math.Abs((double) (  pClose - close)) <   vUseRng)))
            {
                if ((((  pBarDir != 1) || (close >=   pClose)) || (Math.Abs((double) (  pClose - close)) < (  vUseRng *   vRevSize))) && (((  pBarDir > 0) || (close >=   pClose)) || (Math.Abs((double) (  pClose - close)) <   vUseRng)))
                {
                     UpdateBar(bars, close, close, close, close, time, volume, isRealtime);
                      cVolume += volume;
                    goto Label_09FF;
                }
                if (  pBarDir == 0)
                {
                    num2 = Math.Max(  pClose,   nHigh);
                     UpdateBar(bars,   pClose, num2,   pClose -   vUseRng,   pClose -   vUseRng, time,   cVolume, isRealtime);
                      pClose -=   vRevSizeDraw *   vUseRng;
                      pClose +=   hlfRngDraw;
                      pBarDir = 1;
                     AddBar(bars,   pClose,   pClose,   pClose,   pClose, time, 0L, isRealtime);
                }
                if ((((  pBarDir == 1) && (close <   pClose)) && (Math.Abs((double) (  pClose - close)) >= ((  vUseRng *   vRevSize) * 2.0))) || (((  pBarDir <= 0) && (close <   pClose)) && (Math.Abs((double) (  pClose - close)) >= (  vUseRng * 2.0))))
                {
                      cVolume = 0L;
                }
                else
                {
                      cVolume += volume;
                }
                if ((((  pBarDir == 1) && (close <   pClose)) && (Math.Abs((double) (  pClose - close)) >= (  vUseRng *   vRevSize))) || (((  pBarDir <= 0) && (close <   pClose)) && (Math.Abs((double) (  pClose - close)) >=   vUseRng)))
                {
                    do
                    {
                        if (  pBarDir == 1)
                        {
                            num2 = Math.Max(  nHigh,   pClose - (1.0 *   vUseRng));
                            bars.RemoveLastBar(isRealtime);
                             AddBar(bars,   pClose, num2,   pClose - (  vRevSizeDraw *   vUseRng),   pClose - (  vRevSizeDraw *   vUseRng), time,   cVolume, isRealtime);
                              pClose -=   vRevSizeDraw *   vUseRng;
                              pClose +=   hlfRngDraw;
                             AddBar(bars,   pClose,   pClose,   pClose,   pClose, time, 0L, isRealtime);
                        }
                        if (((  pBarDir <= 0) && (close <   pClose)) && (Math.Abs((double) (  pClose - close)) <   vUseRng))
                        {
                              cVolume = volume;
                        }
                        if (  pBarDir <= 0)
                        {
                            num2 = Math.Max(  nHigh,   pClose);
                             UpdateBar(bars,   pClose, num2,   pClose -   vUseRng,   pClose -   vUseRng, time,   cVolume, isRealtime);
                              pClose -=   hlfRng;
                             AddBar(bars,   pClose,   pClose,   pClose,   pClose, time, 0L, isRealtime);
                        }
                          nLow =   pClose;
                          nHigh =   pClose;
                          cVolume = 0L;
                          pBarDir = -1;
                          vTickCount = 0;
                    }
                    while (((  pBarDir <= 0) && (close <   pClose)) && (Math.Abs((double) (  pClose - close)) >=   vUseRng));
                }
            }
            else
            {
                if (  pBarDir == 0)
                {
                    num = Math.Min(  pClose,   nLow);
                     UpdateBar(bars,   pClose,   pClose +   vUseRng, num,   pClose +   vUseRng, time,   cVolume, isRealtime);
                      pClose +=   vRevSizeDraw *   vUseRng;
                      pClose -=   hlfRngDraw;
                      pBarDir = -1;
                     AddBar(bars,   pClose,   pClose,   pClose,   pClose, time, 0L, isRealtime);
                }
                if ((((  pBarDir == -1) && (close >   pClose)) && (Math.Abs((double) (  pClose - close)) >= ((  vUseRng *   vRevSize) * 2.0))) || (((  pBarDir >= 0) && (close >   pClose)) && (Math.Abs((double) (  pClose - close)) >= (  vUseRng * 2.0))))
                {
                      cVolume = 0L;
                }
                else
                {
                      cVolume += volume;
                }
                if ((((  pBarDir == -1) && (close >   pClose)) && (Math.Abs((double) (  pClose - close)) >= (  vUseRng *   vRevSize))) || (((  pBarDir >= 0) && (close >   pClose)) && (Math.Abs((double) (  pClose - close)) >=   vUseRng)))
                {
                    do
                    {
                        if (  pBarDir == -1)
                        {
                            num = Math.Min(  pClose + (1.0 *   vUseRng),   nLow);
                            bars.RemoveLastBar(isRealtime);
                             AddBar(bars,   pClose,   pClose + (  vUseRng *   vRevSizeDraw), num,   pClose + (  vUseRng *   vRevSizeDraw), time,   cVolume, isRealtime);
                              pClose +=   vRevSizeDraw *   vUseRng;
                              pClose -=   hlfRngDraw;
                             AddBar(bars,   pClose,   pClose,   pClose,   pClose, time, 0L, isRealtime);
                        }
                        if (((  pBarDir >= 0) && (close >   pClose)) && (Math.Abs((double) (  pClose - close)) <   vUseRng))
                        {
                              cVolume = volume;
                        }
                        if (  pBarDir >= 0)
                        {
                            num = Math.Min(  pClose,   nLow);
                             UpdateBar(bars,   pClose,   pClose +   vUseRng, num,   pClose +   vUseRng, time,   cVolume, isRealtime);
                              pClose +=   hlfRng;
                             AddBar(bars,   pClose,   pClose,   pClose,   pClose, time, 0L, isRealtime);
                        }
                          nLow =   pClose;
                          nHigh =   pClose;
                          cVolume = 0L;
                          pBarDir = 1;
                          vTickCount = 0;
                    }
                    while (((  pBarDir >= 0) && (close >   pClose)) && (Math.Abs((double) (  pClose - close)) >=   vUseRng));
                }
                  nLow = double.MaxValue;
                  nHigh = 0.0;
                goto Label_09FF;
            }
              nLow = double.MaxValue;
              nHigh = 0.0;
        Label_09FF:
            bars.LastPrice = close;
        }

        public override void ApplyDefaults(BarsData barsData)
        {
            barsData.DaysBack = 5;
            barsData.Period.Value = 5;
            barsData.Period.Value2 = 200;
            barsData.Period.BasePeriodValue = 50;
        }

        public override string ChartDataBoxDate(DateTime time)
        {
            return time.ToString(NinjaTrader.Cbi.Globals.CurrentCulture.DateTimeFormat.ShortDatePattern);
        }

        public override string ChartLabel(ChartControl chartControl, DateTime time)
        {
            return time.ToString(chartControl.LabelFormatSecond, NinjaTrader.Cbi.Globals.CurrentCulture);
        }

        public override object Clone()
        {
            return new RenkoPercent();
        }

        private bool CountBars()
        {
            return true;
        }

        public override int GetInitialLookBackDays(Period period, int barsBack)
        {
            return 1;
        }

        private void GetInputs(Bars bars, double close, DateTime iTime)
        {
              vTickMult = 1.0;
            if ((bars.Instrument.MasterInstrument.TickSize == 1E-05) || (bars.Instrument.MasterInstrument.TickSize == 0.001))
            {
                  vTickMult = 10.0;
            }
              pBarDir = 0;
              vFilter = 1;
              vRevSize = ((double) Math.Max(100, bars.Period.Value2)) / 100.0;
              vReference = 0;
              vRevSizeDraw = 1.0;
              vInputRng = Math.Floor((double) ((10000000.0 * bars.Period.Value) * bars.Instrument.MasterInstrument.TickSize)) / 10000000.0;
            if (  vInputRng != 0.0)
            {
                  vUseRng =   vInputRng;
                double num = ((double) bars.Period.BasePeriodValue) / 100.0;
                  hlfRng = bars.Instrument.MasterInstrument.Round2TickSize(Math.Max(  vInputRng * Math.Max(num, 0.0), bars.Instrument.MasterInstrument.TickSize));
                  hlfRngDraw = bars.Instrument.MasterInstrument.Round2TickSize(  vInputRng) -   hlfRng;
            }
              lTime = iTime.TimeOfDay.TotalSeconds;
              pTick =   cTick;
              cTick = close;
              pDate =   cDate;
              cDate = iTime.Date.DayOfYear;
              pTime =   cTime;
              cTime = iTime.TimeOfDay.TotalMilliseconds;
              pTickIgnore =   cTickIgnore;
              cTickIgnore = 0;
        }

        public override double GetPercentComplete(Bars bars, DateTime now)
        {
            int num = bars.Period.Value / 100;
            if (now <= bars.Get(bars.Count - 1).Time)
            {
                return (1.0 - (bars.Get(bars.Count - 1).Time.Subtract(now).TotalSeconds / ((double) num)));
            }
            return 0.0;
        }

        public override PropertyDescriptorCollection GetProperties(PropertyDescriptor propertyDescriptor, Period period, Attribute[] attributes)
        {
            PropertyDescriptorCollection properties =  GetProperties(propertyDescriptor, period, attributes);
            properties.Remove(properties.Find("BasePeriodType", true));
            properties.Remove(properties.Find("PointAndFigurePriceType", true));
            properties.Remove(properties.Find("ReversalType", true));
            NinjaTrader.Gui.Design.DisplayNameAttribute.SetDisplayName(properties, "Value", "\rBrick Size");
            NinjaTrader.Gui.Design.DisplayNameAttribute.SetDisplayName(properties, "Value2", "\rReversal %");
            NinjaTrader.Gui.Design.DisplayNameAttribute.SetDisplayName(properties, "BasePeriodValue", "\rOpen %");
            return properties;
        }

        private int TimeToSec(DateTime iTime)
        {
            return ((((iTime.Hour * 0xe10) + (iTime.Minute * 60)) + iTime.Second) + (iTime.Millisecond / 0x3e8));
        }

        public override string ToString(Period period)
        {
            return ("RenkoPercent - " + period.Value.ToString() + " T, " + period.BasePeriodValue.ToString() + "% Open, " + period.Value2.ToString() + "% Rev");
        }

        public override PeriodType BuiltFrom
        {
            get
            {
                return PeriodType.Tick;
            }
        }

        public override ChartStyleType[] ChartStyleTypesSupported
        {
            get
            {
                ChartStyleType[] typeArray = new ChartStyleType[5];
                typeArray[1] = ChartStyleType.CandleStick;
                typeArray[2] = ChartStyleType.HiLoBars;
                typeArray[3] = ChartStyleType.LineOnClose;
                typeArray[4] = ChartStyleType.OHLC;
                return typeArray;
            }
        }

        public override int DefaultValue
        {
            get
            {
                return 5;
            }
        }

        public override string DisplayName
        {
            get
            {
                return "RenkoPercent";
            }
        }

        public override bool IsIntraday
        {
            get
            {
                return true;
            }
        }
    }
}

